<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\LogsynckapalModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class LogsynckapalService extends BaseService
{
    /**
     * LogsynckapalModel constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->model = new LogsynckapalModel();
    }

    /**
     *  index function that get all data from database by default
     * @return array|static[]
     */
    public function index()
    {
        return $this->model->getQuery()->get();
    }


    /**
     *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
     * @param array $input
     * @return array
     */
    public function paging($input)
    {        
        if(! isset($input["sort"])) {
			$this->model->getQuery()->orderBy("logsynckapal.process_date", "desc");
		} else {
            $this->model->getQuery();
        } 
        $this->model->paging()->filter()->sorting();
        return $this->model->paging()->getPaging();
    }

    /**
     *  get one raw row data from table by id
     *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
     *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
     *  and you want to take value like this $model->fieldname
     * @param $id
     * @return LogsynckapalModel
     */
    public function show($id)
    {
        $model = $this->model->getQuery()->where("logsynckapal.id", "=", $id)->first();
        return $model;
    }

    public function getLatestUpdate($processName) {
        $model = (new LogsynckapalModel())::where("logsynckapal.process_name", "ILIKE", $processName . "%")
                ->orderBy("process_date", "DESC")
                ->first();
        return $model;
    }
}